# Three Case Studies on Realms

This file provides an entry point for the formalizations that are part of the paper Three Case Studies on Realms.
The formulations are integrated with the heavily modular LATIN2 library and are split over the following files.

### Lattices

The algebraic formulation:
* https://gl.mathhub.info/MMT/LATIN2/-/tree/devel/source/domain_theories/algebra/magmas.mmt  
* https://gl.mathhub.info/MMT/LATIN2/-/tree/devel/source/domain_theories/algebra/monoids.mmt  
* https://gl.mathhub.info/MMT/LATIN2/-/tree/devel/source/domain_theories/algebra/lattices.mmt  

The order-based formulation:
* https://gl.mathhub.info/MMT/LATIN2/-/blob/devel/source/domain_theories/relations/orders.mmt  
* https://gl.mathhub.info/MMT/LATIN2/-/blob/devel/source/domain_theories/relations/lattices.mmt  


### Topological Spaces

The definitions:
* https://gl.mathhub.info/MMT/LATIN2/-/blob/devel/source/domain_theories/topology/definitions.mmt  

The isomorphisms:
* https://gl.mathhub.info/MMT/LATIN2/-/blob/devel/source/domain_theories/topology/equivalences.mmt  

The integration into a single theory:
* https://gl.mathhub.info/MMT/LATIN2/-/blob/devel/source/domain_theories/topology/topology.mmt  

### Natural Numbers

The axiomatic formulation:
* https://gl.mathhub.info/MMT/LATIN2/-/blob/devel/source/domain_theories/numbers/numbers.mmt  
* https://gl.mathhub.info/MMT/LATIN2/-/blob/devel/source/domain_theories/numbers/nat_axiomatic.mmt    

The formulation using binary arithmetic and the respective isomorphisms:
* https://gl.mathhub.info/MMT/LATIN2/-/blob/devel/source/domain_theories/numbers/nat_binary.mmt  
* https://gl.mathhub.info/MMT/LATIN2/-/blob/devel/source/domain_theories/numbers/nat_realm.mmt 

The formulation using Church numerals:
* https://gl.mathhub.info/MMT/LATIN2/-/blob/devel/source/domain_theories/numbers/nat_church.mmt  


The formulation using set theory:
* various files in the folder https://gl.mathhub.info/MMT/LATIN2/-/blob/devel/source/set-theory in particular nats.mmt
* https://gl.mathhub.info/MMT/LATIN2/-/blob/devel/source/set-theoretical_semantics/numbers/nat.mmt
